<?php

namespace App\Controllers\Admin;


use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

use App\Services\MyLogService;
use App\Helpers\MyLogHelper;
use App\Services\UserService;

class MyLogController extends AdminController
{
    private $_helper = null;
    private $_userService = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    final public function getService(): MyLogService
    {
        if (!$this->_service) {
            $this->_service = new MyLogService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): MyLogHelper
    {
        if (!$this->_helper) {
            $this->_helper = new MyLogHelper($this->request);
        }
        return $this->_helper;
    }
    public function getUserService(): UserService
    {
        if (!$this->_userService) {
            $this->_userService = new UserService($this->request);
        }
        return $this->_userService;
    }
    //Index,FieldForm관련
    protected function getFormFieldOption(string $field, array $options): array
    {
        switch ($field) {
            case 'user_uid':
                $temps = [];
                foreach ($this->getUserService()->getEntities() as $entity) {
                    $temps[$entity->getPK()] = $entity->getTitle();
                }
                $options[$field] = $temps;
                break;
            default:
                $options = parent::getFormFieldOption($field, $options);
                break;
        }
        return $options;
    }
    //Index,FieldForm관련
}
